/* ---------------------------------------------

	[ fileio.c ]

	t@CANZX֘ATu[`
	(c) 2010, By Y.Kyotani

--------------------------------------------- */

#include 	<string.h>
#include 	<avr/io.h>
#include 	<avr/pgmspace.h>
#include 	<avr/interrupt.h>
#include 	"diskio.h"
#include 	"pff.h"
#include 	"xitoa.h"

#include	"oledsub.h"
#include	"timer168.h"
#include	"keyin.h"
#include	"fileio.h"


/* [NGA` */
BYTE	buff[BUFFERSIZE];			// t@CI/Oєėpobt@

/* [J֐vg^Cv */
int IsErrContinue(FRESULT rc);
void put_rc (FRESULT rc);
char *SaveFName(char *ptr);
WORD GetAction(WORD pos, WORD num, FILINFO *fip);
void DispFlist(WORD pos, WORD num, FILINFO *fip);
WORD DispSelFile(WORD pos, WORD num, FILINFO *fip);

/* ---------------------------------------------

	Petit-FatFs̃G[e\

--------------------------------------------- */

/* ʕ`pf[^ */
const prog_char rcdata0[]=			// EBhE
	{
	GCE_BGCOLOR,   0,  0,  0,
	GCE_BOXF,      0,  2, 48,  0,126, 36,
	GCE_BGCOLOR, 255,  0,  0,
	GCE_BOXF,      0,  0, 46,  0,126, 36,
	GCE_FGCOLOR, 255,  0,  0,
	GCE_BGCOLOR, 255,255,255,
	GCE_BOXF,      0,  2, 48,  0, 88, 11,
	GCE_LOCATE,    0,  6, 50,
	'I','/','O',' ','E','R','R','O','R','!',
	GCE_FGCOLOR, 255,255,255,
	GCE_BGCOLOR, 255,  0,  0,
	GCE_LOCATE,    0,  4, 62,
	'\0'
	};

/* G[e^CAEgtŉʕ\ */
FRESULT PutRCOK(FRESULT rc, WORD time)
	{
	void	*funcsave;
	
	if	(rc == FR_OK)
		return	rc;

	funcsave = xfunc_out;
	xfunc_out= (void *)OLEDPutChr;
	
	OLEDPutStr	(rcdata0);
	put_rc		(rc);
	WaitKeyPushOK	(time);
	
	xfunc_out = funcsave;
	return	rc;
	}

/* G[e𕶎ɉH */
void put_rc (FRESULT rc)
	{
	const prog_char *p;
static	const prog_char str[] =
	"OK\0" "DISK_ERR\0" "NOT_READY\0" "NO_FILE\0" "NO_PATH\0"
	"NOT_OPENED\0" "NOT_ENABLED\0" "NO_FILE_SYSTEM\0" "ERR8\0" "ERR9\0"
	"Illegal Header\0" "Illegal Image Size\0" "Illegal Data\0";
	FRESULT	i;

	for	(p = str, i = 0; i != rc && pgm_read_byte_near(p); i++)
		{ while(pgm_read_byte_near(p++)); }
	
	xprintf(PSTR("rc=%u FR_%S"), (WORD)rc, p);
	}

/* ---------------------------------------------

	G[mF̃L[҂
	time <-- msPʂ̃^CAEg(0:)
	ret --> 0:^CAEgA-1:L[

--------------------------------------------- */

/* ʕ`pf[^ */
const prog_char okdata0[]=			// uOKv{^̃f[^
	{
	GCE_BGCOLOR,   0,  0,  0,
	GCE_BOXF,      0,100,112,  0, 24, 12,
	GCE_BGCOLOR, 255,255,255,
	GCE_BOXF,      0, 98,110,  0, 24, 12,
	GCE_FGCOLOR,   0,  0,  0,
	GCE_LOCATE,    0,102,112,
	'O','K',
	GCE_FGCOLOR, 255,255,255,
	GCE_BGCOLOR,   0,  0,  0,
	'\0'
	};

int WaitKeyPushOK(WORD time)
	{
	OLEDPutStr	(okdata0);
	return		(WaitKeyPush(time)? -1: 0);
	}					// uOKvȊOł^b`ꂽ߂

/* ---------------------------------------------

	G[Ɍp\؂蕪
	rc  <-- G[R[h
	ret --> 1:pA0:s

--------------------------------------------- */
int IsErrContinue(FRESULT rc)
	{
	switch	(rc)
		{
		case	FR_DISK_ERR:		// t@CVXesȂ
		case	FR_NOT_READY:		// J[hꂽꍇȂ
		case	FR_NOT_ENABLED:		// sSȂ
		case	FR_NO_FILESYSTEM:
			return	0;		// psԂ(vR[hX^[g)
		default:
			return	1;		// ȊO͌pԂ
		}
	}


/* ---------------------------------------------

	Opeñt@Cp֐
	ptr <-- buffɑ݂镶
	ret --> staticȏꏊɃRs[ꂽ

--------------------------------------------- */
char *SaveFName(char *ptr)
	{
static	char	savedstring[14];
	BYTE	s1;
	
	for	(s1=0; s1<sizeof(savedstring); s1++)
		{
		savedstring[s1]= *ptr++;
		if	(! savedstring[s1])
			break;
		}
	return	savedstring;
	}


/* ---------------------------------------------

	SDJ[ht@Cꗗǂݏo
	IꂽACes
	Fs͐䂪߂Ȃ

--------------------------------------------- */

/* ʕ`pf[^ */
const prog_char dispdata1[]=			// EBhE
	{
	GCE_BGCOLOR,   0,  0,128,
	GCE_BOXF,      0,  0,  0,  0, 128, 128,
	GCE_FGCOLOR, 255,255,255,
	'\0'
	};

const prog_char dispdata2[]=			// J[\p(ʏ\)
	{
	GCE_BGCOLOR, 255,255,255,
	GCE_FGCOLOR,   0,  0,128,
	'\0'
	};

const prog_char dispdata3[]=			// J[\p(]\)
	{
	GCE_BGCOLOR,   0,  0,128,
	GCE_FGCOLOR, 255,255,255,
	'\0'
	};

/* SDJ[ht@CꗗǂݏođIꂽACes */
FRESULT ProcessFList(void)
	{
	DIR	dir;
	FILINFO	*fip;
	FRESULT	res;
	BYTE	cur, cub, loopf, tc;
	WORD	s1, s2, s3, act;
	void	*funcsave;
static	FILINFO selfile;
	
	/* ʂ`悷 */
	funcsave = xfunc_out;			// xprintfo͐ݒ
	xfunc_out= (void *)OLEDPutChr;
	
	s3 = 0;	cur= 0;	res= 0;
	
	for	( ; ; )
		{
		OLEDPutStr	(dispdata1);	// EBhEʂ̕`
		
		/* fBNgXg̎擾 */
		if	(!s3)
			{			// fBNgXg̎擾
			buff[0]= '\0';
			if	((res=pf_opendir(&dir, (char *)buff)) != FR_OK)
				break;		// G[Ȃ甲
			cur= 0;	s1= 0;
			fip= (FILINFO *)buff;
			}
		else
			{			// fBNgXǧp擾
			cur= 1;	s1= 2;
			fip= (FILINFO *)buff + 2;
			}
		
		do
			{			// fBNgXg̎擾[v
			if	((res=pf_readdir(&dir, fip)) != FR_OK)
				break;		// G[Ȃ甲
			if	(!fip->fname[0])
				break;		// Ō܂œǂݍ
			if	(fip->fattrib & AM_DIR)
				continue;	// TufBNg͑ΉO(ǂݔ΂)
			s1++;	fip++;
			}
		while	(s1 < MAXDIRS);
		
		if	(res != FR_OK)		// Xg擾̃G[Δ
			break;			// ps\ȃG[΂̃nY
		
		/* 擾fBNgXgʕ\ */
		fip= (FILINFO *)buff;
		for	(s2=0; s2<s1; s2++)
			DispFlist (s2, s3+s2, fip++);
		
		/* t@CȈ[v */
		for	( ; ; )
			{			// J[\Ƃ̏ꏊ̃t@C\
			fip= (FILINFO *)buff + (WORD)cur;
			act= DispSelFile(cur, s3+cur, fip);	// s敪擾Ă
			OLEDPutStr	(dispdata2);		// ]J[\\
			DispFlist	(cur, s3+cur, fip);
			cub= cur;
			
			/* L[͑҂Ə[v */
			for	( ; ; )
				{
				switch	(tc= GetKeyPush())
					{		// Cursor UP͊Y{^Ȃ
					case	0x01:	// Cursor DOWN
						if	(++cur >= s1)
							cur= 0;
						break;
					
					case	0x02:	// ENTER
						break;
					default:
						continue;
					}
				break;
				}
			
			OLEDPutStr	(dispdata3);	// ]J[\
			DispFlist	(cub, s3+cub, fip);
			
			if	(tc != 0x02)
				continue;	// ENTERȊOIꂽJԂ
			
			loopf= 0;
			
			/* Is敪ɂď */
			switch	(act)
				{
				case	1:	// Goto Next Page
					fip= (FILINFO *)buff;
					fip[1]= fip[MAXDIRS-1];
					s3 += MAXDIRS-2;
					loopf= 1;
					break;
				
				case	2:	// Goto Top Page
					s3= 0;
					loopf= 1;
					break;
				case	3:	// View File
					selfile= *fip;	// t@CStaticȏꏊɃRsĂ
					GCls	(0x0000);
					if	((res=ProcessGFile(selfile.fname)) != FR_OK
						&& !IsErrContinue(res))
						{	// G[Ōps̏ꍇ
						xfunc_out= funcsave;
						return	res;
						}
					loopf= 0;
					break;
				case	4:	// Exec File
					selfile= *fip;	// t@CStaticȏꏊɃRsĂ
					GCls	(0x0000);
					if	((res=ProcessSeqFile(selfile.fname)) != FR_OK
						&& !IsErrContinue(res))
						{	// G[Ōps̏ꍇ
						xfunc_out= funcsave;
						return	res;
						}
					loopf= 0;
					break;
				default:
					continue;
				}
			break;
			}
		
		/* ʃt@Cšnƍď */
		if	(!loopf)
			{
			MSTimer		(500);		// ԑ҂0.5b
			WaitKeyPushOK	(0);		// uOKv\ĊmF
			s3 = 0;	cur= 0;			// fBNgXgĎ擾̐ݒ
			}
		}
	
	xfunc_out= funcsave;
	return	(PutRCOK(res, 0));		// G[e(Ă͂)\Ė߂
	}


/* t@C̎s敪擾Tu[` */
WORD GetAction(WORD pos, WORD num, FILINFO *fip)
	{
	WORD	act, i;
	char	*p;
	
	if	(pos+1 >= MAXDIRS)
		act= 1;				// ŏIsɂACe͎ŌJz
	else if	(!pos && num)
		act= 2;				// 2Ŗڈȍ~̐擪s"Go To Top"
	else
		{
		p= fip->fname;	act= 0;		// t@Cgqɂs敪
		for	(i=0; i<9; i++)
			{
			if	(*p == '\0')
				break;
			if	(*p++ != '.')
				continue;
			if	(p[0]=='R' && p[1]=='1' && p[2]=='6')
				act= 3;		// "*.R16" --> View
			else if	(p[0]=='S' && p[1]=='E' && p[2]=='Q')
				act= 4;		// "*.SEQ" --> Exec
			break;
			}
		}
	
	return	act;
	}

/* t@CXg1s\Tu[` */
void DispFlist(WORD pos, WORD num, FILINFO *fip)
	{
	OLEDSetLocate	(0, 2+pos*10);
	
	switch	(GetAction(pos, num, fip))	// s敪擾
		{
		case	1:			// Next Page
			OLEDPutStr	(PSTR(">>> Next Page >>"));
			return;
		case	2:			// Top Page
			OLEDPutStr	(PSTR("<<< Top Page  <<"));
			return;
		default:			// ʏ̃t@C
			/* t@Cԍƃt@C */
			xprintf(num<999? PSTR("%3u "): PSTR("%03u."), (num+1)%1000);
			OLEDFixWStr(fip->fname, 12);
			
			break;
		}
	}

/* ݑIĂt@C̖OƎs敪KCh֕\ */
WORD DispSelFile(WORD pos, WORD num, FILINFO *fip)
	{
	WORD	act;
	
	/* Locate 0,116, SPC(16), Locate 0, 116 */
	OLEDPutStr	(PSTR(GSTR_LOCATE "\x00\x00\x74"
			 "                " GSTR_LOCATE "\x00\x00\x74"));
	/* s敪擾ăKChɕ\ */
	switch	(act= GetAction(pos, num, fip))
		{
		case	1:
			OLEDPutStr	(PSTR("Go to Next Page."));
			return	act;
		case	2:
			OLEDPutStr	(PSTR("Go to Top Page."));
			return	act;
		case	3:
			OLEDPutStr	(PSTR("Vw"));
			break;
		case	4:
			OLEDPutStr	(PSTR("Ex"));
			break;
		default:
			OLEDPutStr	(PSTR("--"));
			break;
		}
	
	/* t@C\ */
	xprintf(PSTR("\"%s\""), fip->fname);
	return	act;
	}

/* ---------------------------------------------

	ftHgV[PXt@Cs
	"DEFAULT.SEQ"t@C݂Ȃ烋[v

--------------------------------------------- */
FRESULT ProcessDefaultSeqFile(void)
	{
static	char	seqfile[]="DEFAULT.SEQ";
	FRESULT	res;
	
	/* "DEFAULT.SEQ"݂邩`FbN */
	if	((res=pf_open(seqfile)) != FR_OK)	// ݂Ȃꍇ FR_OKԂ
		return	(IsErrContinue(res)? FR_OK: PutRCOK(res, 0));
	
	/* "DEFAULT.SEQ"[vĐ */
	for	( ; ; )
		{
		if	((res=ProcessSeqFile(seqfile)) != FR_OK)
			return	res;
		}
	}

/* ---------------------------------------------

	w肳ꂽV[PXt@Cs

--------------------------------------------- */
FRESULT ProcessSeqFile(char *fname)
	{
	FRESULT	res;
	BYTE	reopen;
	WORD	s1, s2;
	long	l;
	char	*p;
static	DWORD	SeqSeek, LoopSeek;
static	WORD	LoopTime;
	
	SeqSeek= 0L;	reopen= 1;
	LoopSeek= 0L;	LoopTime= 0;
	
	for	( ; ; )
		{
		/* w肳ꂽV[PXt@CI[vēo */
		if	(reopen && (res = pf_open(fname)) != FR_OK)
			break;			// I[vs
		if	((res = pf_lseek(SeqSeek)) != FR_OK)
			break;			// V[Ns
		if	((res = pf_read(buff, SEQRSIZE, &s1)) != FR_OK)
			break;			// ǂݍݎs
		if	(s1 == 0)
			break;			// EOF
		reopen= 0;			// ȂOpensvƂ
		
		/* ŏɎs̐擪Ă */
		p= (char *)buff;	s2= 0;
		for	( ; ; )
			{
			if	(*p=='\r' || *p=='\n' || s2>=s1)
				{ *p= '\0';	break; }	// s}[LO
			if	('a'<=*p && *p<='z')
				*p -= 'a'-'A';			// toupper(*p);
			p++;	s2++;
			}
		while	(s2 < s1)
			{
			s2++;
			if	(*++p > ' ')
				break;
			}
		SeqSeek += (DWORD)s2;		// s̐擪̃V[Nʒuɂ
		
		p= (char *)buff;
		switch	(*p++)
			{
			case	'#':		// Rg
			case	';':
			case	'/':
				break;
			
			case	'G':		// OtBbNC[W
				while	(*p==' ' || *p=='=' || *p==':') p++;
				if	((res=ProcessGFile(SaveFName(p))) != FR_OK)
					{	// G[
					if	(! IsErrContinue(res))
						return	res;	// ps
					}
				reopen= 1;	// ʃt@CĴōOpenKv
				break;
			
			case	'W':		// ԑ҂(ms)
				while	(*p==' ' || *p=='=' || *p==':') p++;
				if	(xatoi(&p, &l))
					MSTimer(l<65536L? (WORD)l: 65535);
				break;
			
			case	'P':		// [U[mF҂(ms)
				while	(*p==' ' || *p=='=' || *p==':') p++;
				if	(! xatoi(&p, &l))
					l= 0;
				WaitKeyPushOK(l<65536L? (WORD)l: 65535);
				break;
			
			case	'{':		// [vJn
				while	(*p==' ' || *p=='=' || *p==':') p++;
				if	(! xatoi(&p, &l))
					l= 0;
				LoopTime= l<65536L? (WORD)l: 65535;
				LoopSeek= SeqSeek;
				break;		// [v񐔂ƊJn|C^(s擪)ۑ
			
			case	'}':		// [vI
				if	(LoopTime)
					{
					if	(--LoopTime == 0)
						break;
					}
				SeqSeek= LoopSeek;
				break;		// JEg1ȊO̓|C^߂ă[v
				
			case	'E':		// I
				return	FR_OK;
			}
		
		}
	
	return	(PutRCOK(res, 0));		// G[e(Ă)\Ė߂
	}

/* ---------------------------------------------

	w肳ꂽOtBbNt@C\
	ret: FRESULT (ǉG[R[h܂)

--------------------------------------------- */
FRESULT ProcessGFile(char *fname)
	{
	FRESULT	res;
	BYTE	itvf;
	WORD	s1, rcnt;
	DWORD	dlen;
	BGRHEADER	*hdr;

	/* w肳ꂽt@CJHeaderǂ */
	for	( ; ; )
		{
		if	((res=pf_open(fname)) != FR_OK)
			break;			// t@CȂ̏ꍇłG[ƂĈ
		if	((res=pf_read(buff, BUFFERSIZE, &s1)) != FR_OK)
			break;			// [hG[
		if	(s1 < BUFFERSIZE)
			res= 10;		// ǉG[R[h (10: Illegal Header)
		break;
		}
	
	if	(res != FR_OK)
		return	(PutRCOK(res, 0));	// G[Ȃe\Ė߂
	
	itvf= 0;				// Header͓ǂނ͂Ȃ
	
	/* Header߂ăEBhEGAݒ聕{̂ǂ */
	for	( ; ; )
		{
		hdr= (BGRHEADER *)buff;
		if	(strcmp_P(hdr->idstr, PSTR("bgr16")))
			{ res= 10; break; }	// ǉG[R[h (10: Illegal Header)
		
		/* Õ[vintervalw肪ꍇ̓ */
		if	(itvf)			{ TimerWait(); }
		
		/* ̃[vintervalw肪ꍇ̓w */
		if	(hdr->interval)		{ MSTimerSet(hdr->interval); itvf= 1; }
		else if	(hdr->dispnops)		{ NNTimerSet(hdr->dispnops); itvf= 2; }
		else				{ itvf= 0; }
		
		/* \ʒũEBhEGAݒ */
		if	(SetWindowArea	(hdr->dx, hdr->dy, hdr->ofsx, hdr->ofsy) > 1)
			{ res= 11; break; }	// ǉG[R[h (11: Illegal Image Size)
		
		dlen= (DWORD)hdr->dx * (DWORD)hdr->dy * 2L;
		
		while	(dlen)
			{
			/* f[^{̂BUFFERSIZEPʂœǂ */
			rcnt= dlen > BUFFERSIZE? BUFFERSIZE: (WORD)dlen;
			if	((res= pf_read(NULL, rcnt, &s1)) != FR_OK)
				break;			// ǂݍ݃G[
			if	(s1 != rcnt)
				{ res=12; break; }	// ǉG[R[h (12: Illegal Data)
			
			/* [̃f[^oꍇɃtB[ǂݔ΂(ǂ߂ȂĂs) */
			if	(rcnt < BUFFERSIZE)
				pf_read(buff, BUFFERSIZE-rcnt, &s1);
			
			dlen -= (DWORD)rcnt;
			}
		
		if	(res)	break;
		
		/* Intervalw肪ΊȈՓƂ݂ȂĎHeaderǂ */
		if	(itvf)
			{
			if	((res=pf_read(buff, BUFFERSIZE, &s1)) != FR_OK)
				break;
			if	(s1 < BUFFERSIZE)
				{ itvf= 0; break; }		// ǂ߂ȂĂs(EOFƈ)
			
			continue;		// ȈՓ͎̃ubNǂށFLoop
			}
		break;				// Î~͂ŏI
		}
	
	InitWindowArea	();			// EBhEGAlɖ߂
	return	(PutRCOK(res, 0));		// G[e(Ă)\Ė߂
	}

// End of fileio.c
